/// <reference types="react" />
import { WrapperProps, WrapperChildProps } from './types';
export interface GridProps extends WrapperProps<GridChildProps> {
    readonly rowDefinitions?: ReadonlyArray<GridRowDefinition>;
    readonly columnDefinitions?: ReadonlyArray<GridColumnDefinition>;
}
export interface GridRowDefinition {
    readonly height?: number | string;
}
export interface GridColumnDefinition {
    readonly width?: number | string;
}
export interface GridChildProps extends WrapperChildProps {
    readonly gridRow?: number;
    readonly gridColumn?: number;
    readonly gridRowSpan?: number;
    readonly gridColumnSpan?: number;
}
export declare const GridChild: (props: GridChildProps) => JSX.Element;
export declare const Grid: (props: GridProps) => JSX.Element;
