import { HTMLAttributes, ReactElement } from 'react';
export declare type Orientation = 'horizontal' | 'vertical';
export declare type Direction = 'left-to-right' | 'right-to-left';
export interface SequenceWrapperProps {
    readonly orientation?: Orientation;
    readonly direction?: Direction;
}
export interface WrapperChildProps extends HTMLAttributes<HTMLDivElement> {
}
export declare type WrapperChildNode<T extends WrapperChildProps> = ReactElement<T>;
declare type HTMLAttributesOfDivElementExceptChildren = Pick<HTMLAttributes<HTMLDivElement>, Exclude<keyof HTMLAttributes<HTMLDivElement>, 'children'>>;
export interface WrapperProps<TChild extends WrapperChildProps> extends HTMLAttributesOfDivElementExceptChildren {
    readonly children: ReadonlyArray<WrapperChildNode<TChild>>;
}
export declare type WrapperNode = ReactElement<WrapperProps<WrapperChildProps>>;
export {};
